class Mythread extends Thread {
  buffer b;
  boolean prod;
  
  public Mythread(buffer buf, boolean p) {
    b = buf;
    prod = p;
  }
  
  public void run() {
    for (int i=0; i<10000; i++) {
      if (prod) {
        b.write(i);
        System.out.println("Prod generate "+i);
      } else {
        int item = b.read();
        System.out.println("Cons receive "+item);
      }
    }
  }
  
  public static void main(String[] args) {
    buffer bb = new buffer();
    Mythread prod = new Mythread(bb, true);
    Mythread cons = new Mythread(bb, false);
    prod.start(); 
    cons.start();
  }
}

class buffer {
  final int SIZE = 10;
  int a_size;
  int rd_ptr, wr_ptr;
  int a[];
  
  public buffer() {
    a = new int[SIZE];
    a_size = 0;
    rd_ptr = wr_ptr = 0;
  }

  public synchronized int read() {
    int r;
    while (a_size<=0) {
      try {
        wait();
      } catch (InterruptedException e) {}
    }
    a_size--;
    r = a[rd_ptr++];
    rd_ptr = rd_ptr%SIZE;
    if (a_size == SIZE-1) {
      notifyAll();
    }
    return r;
  }
  
  public synchronized void write(int x) {
    while (a_size>=SIZE) {
      try {
        wait();
      } catch (InterruptedException e) {}
    }
    a_size++;
    a[wr_ptr++]=x;
    wr_ptr = wr_ptr % SIZE;
    if (a_size==1) {
      notifyAll();
    }
  }
}
